Create assistant
post /assistants
Create an assistant with a model and instructions.
Body Parameters
-
model: string or "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
string -
AssistantSupportedModels = "gpt-5" or "gpt-5-mini" or "gpt-5-nano" or 39 moreID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
"gpt-5" -
"gpt-5-mini" -
"gpt-5-nano" -
"gpt-5-2025-08-07" -
"gpt-5-mini-2025-08-07" -
"gpt-5-nano-2025-08-07" -
"gpt-4.1" -
"gpt-4.1-mini" -
"gpt-4.1-nano" -
"gpt-4.1-2025-04-14" -
"gpt-4.1-mini-2025-04-14" -
"gpt-4.1-nano-2025-04-14" -
"o3-mini" -
"o3-mini-2025-01-31" -
"o1" -
"o1-2024-12-17" -
"gpt-4o" -
"gpt-4o-2024-11-20" -
"gpt-4o-2024-08-06" -
"gpt-4o-2024-05-13" -
"gpt-4o-mini" -
"gpt-4o-mini-2024-07-18" -
"gpt-4.5-preview" -
"gpt-4.5-preview-2025-02-27" -
"gpt-4-turbo" -
"gpt-4-turbo-2024-04-09" -
"gpt-4-0125-preview" -
"gpt-4-turbo-preview" -
"gpt-4-1106-preview" -
"gpt-4-vision-preview" -
"gpt-4" -
"gpt-4-0314" -
"gpt-4-0613" -
"gpt-4-32k" -
"gpt-4-32k-0314" -
"gpt-4-32k-0613" -
"gpt-3.5-turbo" -
"gpt-3.5-turbo-16k" -
"gpt-3.5-turbo-0613" -
"gpt-3.5-turbo-1106" -
"gpt-3.5-turbo-0125" -
"gpt-3.5-turbo-16k-0613"
-
-
-
description: optional stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: optional stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: optional stringThe name of the assistant. The maximum length is 256 characters.
-
reasoning_effort: optional ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high,xhigh, andmax. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response. Not all reasoning models support every value. See the reasoning guide for model-specific support.-
"none" -
"minimal" -
"low" -
"medium" -
"high" -
"xhigh" -
"max"
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the
code_interpretertool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids, vector_stores }-
vector_store_ids: optional array of stringThe vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
vector_stores: optional array of object { chunking_strategy, file_ids, metadata }A helper to create a vector store with file_ids and attach it to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
chunking_strategy: optional object { type } or object { static, type }The chunking strategy used to chunk the file(s). If not set, will use the
autostrategy.-
AutoChunkingStrategy object { type }The default strategy. This strategy currently uses a
max_chunk_size_tokensof800andchunk_overlap_tokensof400.-
type: "auto"Always
auto."auto"
-
-
StaticChunkingStrategy object { static, type }-
static: object { chunk_overlap_tokens, max_chunk_size_tokens }-
chunk_overlap_tokens: numberThe number of tokens that overlap between chunks. The default value is
400.Note that the overlap must not exceed half of
max_chunk_size_tokens. -
max_chunk_size_tokens: numberThe maximum number of tokens in each chunk. The default value is
800. The minimum value is100and the maximum value is4096.
-
-
type: "static"Always
static."static"
-
-
-
file_ids: optional array of stringA list of file IDs to add to the vector store. For vector stores created before Nov 2025, there can be a maximum of 10,000 files in a vector store. For vector stores created starting in Nov 2025, the limit is 100,000,000 files.
-
metadata: optional MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
-
tools: optional array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
Returns
-
Assistant object { id, created_at, description, 10 more }Represents an
assistantthat can call the model and use tools.-
id: stringThe identifier, which can be referenced in API endpoints.
-
created_at: numberThe Unix timestamp (in seconds) for when the assistant was created.
-
description: stringThe description of the assistant. The maximum length is 512 characters.
-
instructions: stringThe system instructions that the assistant uses. The maximum length is 256,000 characters.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: stringID of the model to use. You can use the List models API to see all of your available models, or see our Model overview for descriptions of them.
-
name: stringThe name of the assistant. The maximum length is 256 characters.
-
object: "assistant"The object type, which is always
assistant."assistant"
-
tools: array of CodeInterpreterTool or FileSearchTool or FunctionToolA list of tool enabled on the assistant. There can be a maximum of 128 tools per assistant. Tools can be of types
code_interpreter,file_search, orfunction.-
CodeInterpreterTool object { type }-
type: "code_interpreter"The type of tool being defined:
code_interpreter"code_interpreter"
-
-
FileSearchTool object { type, file_search }-
type: "file_search"The type of tool being defined:
file_search"file_search"
-
file_search: optional object { max_num_results, ranking_options }Overrides for the file search tool.
-
max_num_results: optional numberThe maximum number of results the file search tool should output. The default is 20 for
gpt-4*models and 5 forgpt-3.5-turbo. This number should be between 1 and 50 inclusive.Note that the file search tool may output fewer than
max_num_resultsresults. See the file search tool documentation for more information. -
ranking_options: optional object { score_threshold, ranker }The ranking options for the file search. If not specified, the file search tool will use the
autoranker and a score_threshold of 0.See the file search tool documentation for more information.
-
score_threshold: numberThe score threshold for the file search. All values must be a floating point number between 0 and 1.
-
ranker: optional "auto" or "default_2024_08_21"The ranker to use for the file search. If not specified will use the
autoranker.-
"auto" -
"default_2024_08_21"
-
-
-
-
-
FunctionTool object { function, type }-
function: FunctionDefinition-
name: stringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: optional FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: optional booleanWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: "function"The type of tool being defined:
function"function"
-
-
-
response_format: optional AssistantResponseFormatOptionSpecifies the format that the model must output. Compatible with GPT-4o, GPT-4 Turbo, and all GPT-3.5 Turbo models since
gpt-3.5-turbo-1106.Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables JSON mode, which ensures the message the model generates is valid JSON.Important: when using JSON mode, you must also instruct the model to produce JSON yourself via a system or user message. Without this, the model may generate an unending stream of whitespace until the generation reaches the token limit, resulting in a long-running and seemingly "stuck" request. Also note that the message content may be partially cut off if
finish_reason="length", which indicates the generation exceededmax_tokensor the conversation exceeded the max context length.-
"auto"autois the default value"auto"
-
ResponseFormatText object { type }Default response format. Used to generate text responses.
-
type: "text"The type of response format being defined. Always
text."text"
-
-
ResponseFormatJSONObject object { type }JSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: "json_object"The type of response format being defined. Always
json_object."json_object"
-
-
ResponseFormatJSONSchema object { json_schema, type }JSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: object { name, description, schema, strict }Structured Outputs configuration options, including a JSON Schema.
-
name: stringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: optional stringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: optional map[unknown]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: optional booleanWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: "json_schema"The type of response format being defined. Always
json_schema."json_schema"
-
-
-
temperature: optional numberWhat sampling temperature to use, between 0 and 2. Higher values like 0.8 will make the output more random, while lower values like 0.2 will make it more focused and deterministic.
-
tool_resources: optional object { code_interpreter, file_search }A set of resources that are used by the assistant's tools. The resources are specific to the type of tool. For example, the
code_interpretertool requires a list of file IDs, while thefile_searchtool requires a list of vector store IDs.-
code_interpreter: optional object { file_ids }-
file_ids: optional array of stringA list of file IDs made available to the `code_interpreter`` tool. There can be a maximum of 20 files associated with the tool.
-
-
file_search: optional object { vector_store_ids }-
vector_store_ids: optional array of stringThe ID of the vector store attached to this assistant. There can be a maximum of 1 vector store attached to the assistant.
-
-
-
top_p: optional numberAn alternative to sampling with temperature, called nucleus sampling, where the model considers the results of the tokens with top_p probability mass. So 0.1 means only the tokens comprising the top 10% probability mass are considered.
We generally recommend altering this or temperature but not both.
-
Example
curl https://api.openai.com/v1/assistants \
-H 'Content-Type: application/json' \
-H 'OpenAI-Beta: assistants=v2' \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-d '{
"model": "gpt-4o",
"temperature": 1,
"top_p": 1
}'
Response
{
"id": "id",
"created_at": 0,
"description": "description",
"instructions": "instructions",
"metadata": {
"foo": "string"
},
"model": "model",
"name": "name",
"object": "assistant",
"tools": [
{
"type": "code_interpreter"
}
],
"response_format": "auto",
"temperature": 1,
"tool_resources": {
"code_interpreter": {
"file_ids": [
"string"
]
},
"file_search": {
"vector_store_ids": [
"string"
]
}
},
"top_p": 1
}
Code Interpreter
curl "https://api.openai.com/v1/assistants" \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-d '{
"instructions": "You are a personal math tutor. When asked a question, write and run Python code to answer the question.",
"name": "Math Tutor",
"tools": [{"type": "code_interpreter"}],
"model": "gpt-4o"
}'
Response
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1698984975,
"name": "Math Tutor",
"description": null,
"model": "gpt-4o",
"instructions": "You are a personal math tutor. When asked a question, write and run Python code to answer the question.",
"tools": [
{
"type": "code_interpreter"
}
],
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}
Files
curl https://api.openai.com/v1/assistants \
-H "Content-Type: application/json" \
-H "Authorization: Bearer $OPENAI_API_KEY" \
-H "OpenAI-Beta: assistants=v2" \
-d '{
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies.",
"tools": [{"type": "file_search"}],
"tool_resources": {"file_search": {"vector_store_ids": ["vs_123"]}},
"model": "gpt-4o"
}'
Response
{
"id": "asst_abc123",
"object": "assistant",
"created_at": 1699009403,
"name": "HR Helper",
"description": null,
"model": "gpt-4o",
"instructions": "You are an HR bot, and you have access to files to answer employee questions about company policies.",
"tools": [
{
"type": "file_search"
}
],
"tool_resources": {
"file_search": {
"vector_store_ids": ["vs_123"]
}
},
"metadata": {},
"top_p": 1.0,
"temperature": 1.0,
"response_format": "auto"
}